#ifndef				_VERL_LISTENER_H
#define				_VERL_LISTENER_H

#	ifndef				_REENTRANT
#		define			_REENTRANT
#	endif
/*
	------------------------------------------------------------
	ERLANG C++ Ecnapsulation: Erlang Listener

		Copyright (c) 2002 by Pharos Consulting (Pty) Ltd
		Copyright (c) 2002 by Mobile Telephone Networks.
		
		
	File:		verl_listener.h

	Version:	1.00
	
	Date:		2002-08-26
	Author:		Valentin Micic, Pharos Consulting (Pty) Ltd.

	NOTES:		
	---------------------------------------------------------
	
*/
#include	"ctcp.h"


class VERL_listener 
{
public:
	VERL_listener(	const char* this_node_name,
					const char* my_cookie	);
	virtual ~VERL_listener();

	bool	start( int iPort ); 
	void	stop();

	bool			accept( int & rNewFD_out, int msTimeout=0 );

	// ---------
	// ACCESSORS
	// ---------
	// Remote Node Name (ERLANG SYSTEM)
	inline const char *	remoteNodeName()	{ return m_last_client_details.nodename;}

	// ---------------------------------
	// Remote IP Address (ERLANG SYSTEM) -- NETWORK BYTE ORDER!!
	// ---------------------------------
	inline unsigned long remoteIP()			{ return *((unsigned long*)m_last_client_details.ipadr); }

protected:

	ei_cnode 			m_handle;
	CTCPServer			m_tcpServer;
	ErlConnect			m_last_client_details;
	int					m_empd_fd;		// FD returned by publish!
	bool				m_isStarted;

};

#endif		//		_VERL_LISTENER_H